function _setMappedValue(location, nValue)
	local t = _G
	for w, d in string.gfind(location, "([%w_]+)(.?)") do
		if d == "." then
			if t[w] == nil then
				-- this should always exist, but we could
				-- set t = {} to force the table to exist
				-- if we decide to get crazy with the
				-- function usage
				break
			else
				t = t[w]
			end
		else
			t[w] = nValue
		end
	end
end

function _mappedValue(location)
	local v = _G
	for w in string.gfind(location, "[%w_]+") do
		if v[w] ~= nil then
			v = v[w]
		end
	end
	if v == _G then v = nil end
	return v
end

function _isSafeToRestore(this, that)
	return this ~= nil and that ~= nil and that ~= this
end

function _deepRestore(cMap, sMap)
	local t = _mappedValue(cMap)
	for k, v in pairs(t) do
		local cMap   = cMap .. "." .. k
		local sMap   = sMap .. "." .. k

		if (type(v) == 'table') then
			--recursion
			_deepRestore(cMap, sMap)
		else
			--comparison
			local cValue = _mappedValue(cMap)
			local sValue = _mappedValue(sMap)
			if (_isSafeToRestore(cValue, sValue)) then
				_setMappedValue(cMap, sValue)
			end
		end
	end
end